const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const workout_schedules = sequelize.define(
    'workout_schedules',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

scheduled_start: {
        type: DataTypes.DATE,
      
      

      },

scheduled_end: {
        type: DataTypes.DATE,
      
      

      },

schedule_type: {
        type: DataTypes.ENUM,
      
      

        values: [

"workout",


"rest_day",


"active_recovery"

        ],

      },

notes: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  workout_schedules.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity


















































































































//end loop



    db.workout_schedules.belongsTo(db.users, {
      as: 'user',
      foreignKey: {
        name: 'userId',
      },
      constraints: false,
    });

    db.workout_schedules.belongsTo(db.workouts, {
      as: 'workout',
      foreignKey: {
        name: 'workoutId',
      },
      constraints: false,
    });




    db.workout_schedules.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.workout_schedules.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return workout_schedules;
};


